
package com.tizianhoesch.gibmitnews;

import android.annotation.SuppressLint;
import android.app.ActivityManager;
import android.app.ActivityManager.RunningAppProcessInfo;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.app.PendingIntent;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.graphics.Color;
import android.net.ConnectivityManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.StrictMode;
import android.preference.PreferenceManager;
import android.text.ClipboardManager;
import android.text.util.Linkify;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.AnimationUtils;
import android.view.animation.LayoutAnimationController;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.ArrayAdapter;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;
import android.widget.Toast;

import com.handmark.pulltorefresh.library.PullToRefreshBase.OnRefreshListener;
import com.handmark.pulltorefresh.library.PullToRefreshListView;
import com.tizianhoesch.gibmitnews.alarm.AlarmService;
import com.tizianhoesch.gibmitnews.apprater.AppRater;
import com.tizianhoesch.gibmitnews.database.KlassenlisteDbAdapter;
import com.tizianhoesch.gibmitnews.database.LehrerlisteDbAdapter;
import com.tizianhoesch.gibmitnews.database.NewsDbAdapter;
import com.tizianhoesch.gibmitnews.tools.BerufLehrerDlg;
import com.tizianhoesch.gibmitnews.tools.ShakeListener;
import com.tizianhoesch.gibmitnews.tools.Utility;
import com.urbanairship.push.PushManager;

import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import twitter4j.Paging;
import twitter4j.Status;
import twitter4j.Twitter;
import twitter4j.TwitterException;
import twitter4j.TwitterFactory;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class GIBMITNewsActivity extends ListActivity {
    public static final String TAG = "GIBMITNews";
    private static String TWITTER_USERNAME = "GIBMIT";

    private static final int STUNDENPLAN_REQUEST_CODE = 0x12345A;
    public static final int NOTIFICATION_ID = 0x12345B;
    static final int SETTINGS_REQUEST_CODE = 0x12345C;
    static final int SETTINGS_REQUEST_CODE_ENABLELINKS = 0x12345D;

    private Context myContext = this;

    private ArrayList<String> listNews = new ArrayList<String>();
    private ArrayList<String> listDates = new ArrayList<String>();

    private NewsDbAdapter dbHelper;
    private KlassenlisteDbAdapter dbHelperKlasse;
    private LehrerlisteDbAdapter dbHelperLehrer;
    private Cursor newsCursor;

    PullToRefreshListView pullToRefreshView;

    @SuppressLint("NewApi")
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // StrictMode.ThreadPolicy policy = new
        // StrictMode.ThreadPolicy.Builder()
        // .permitAll().build();
        // StrictMode.setThreadPolicy(policy);
        if (getString("theme", "iphone").equals("iphone")) {
            setTheme(R.style.Theme_White);
        } else {
        }
        setContentView(R.layout.main);
        setTitle(getString(R.string.app_name));

        if (android.os.Build.VERSION.SDK_INT > 9) {
            StrictMode.ThreadPolicy policy =
                    new StrictMode.ThreadPolicy.Builder().permitAll().build();
            StrictMode.setThreadPolicy(policy);
        }

        AppRater apprater = new AppRater();
        apprater.app_launched(myContext);

        int timesStartedUp = getInt("timesStartedUp", 1);

        if (timesStartedUp == 1) {
            AlarmService as = new AlarmService(myContext);
            Date jetzt = new Date();
            java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
                    "HH:mm");
            String ausgabe = sdf.format(jetzt);
            int prefsHrs = Utility.getHour(getString("time", "20:00"));
            int prefsMin = Utility.getMinutes(getString("time", "20:00"));
            int jetztHrs = Utility.getHour(ausgabe);
            int jetztMin = Utility.getMinutes(ausgabe);

            String strJetztHrs = String.valueOf(jetztHrs);
            String strjetztMin = String.valueOf(jetztMin);
            String strprefsHrs = String.valueOf(prefsHrs);
            String strprefsMin = String.valueOf(prefsMin);

            if (String.valueOf(jetztHrs).length() == 1) {
                strJetztHrs = "0" + String.valueOf(jetztHrs);
            }
            if (String.valueOf(jetztMin).length() == 1) {
                strjetztMin = "0" + String.valueOf(jetztMin);
            }
            if (String.valueOf(prefsHrs).length() == 1) {
                strprefsHrs = "0" + String.valueOf(prefsHrs);
            }
            if (String.valueOf(prefsMin).length() == 1) {
                strprefsMin = "0" + String.valueOf(prefsMin);
            }

            String strResultJetzt = strJetztHrs + strjetztMin;
            String strResultPrefs = strprefsHrs + strprefsMin;

            if (Integer.parseInt(strResultJetzt) > Integer
                    .parseInt(strResultPrefs)) {
                as.setRepeatAlarm(Utility.getHour(getString("time", "20:00")),
                        Utility.getMinutes(getString("time", "20:00")), true);
            } else if (Integer.parseInt(strResultJetzt) < Integer
                    .parseInt(strResultPrefs)) {
                as.setRepeatAlarm(Utility.getHour(getString("time", "20:00")),
                        Utility.getMinutes(getString("time", "20:00")), false);
            }

            saveString("time", "20:00");
            saveString("pushtime", "22:00");
            saveString("pushtime2", "08:00");
        }

        if (isWavesecureRunning()) {
            int showOnce = getInt("wavesecure", 1);
            if (showOnce == 1) {
                showWavesecureDialog();
            }
        }

        if (isGTalkRunning()) {
            int showOnce = getInt("gtalk", 1);
            if (showOnce == 1) {
                showTalkDialog();
            }
        }

        saveString("typ", "schueler");

        Intent regIntent = new Intent("com.google.android.c2dm.intent.REGISTER");
        regIntent.putExtra("app", PendingIntent.getBroadcast(
                GIBMITNewsActivity.this, 0, new Intent(), 0));
        regIntent.putExtra("sender", "tizian.hoesch@gmail.com");
        startService(regIntent);

        if (getString("klasse", "").equals("")) {
            Intent intent = new Intent(Intent.ACTION_VIEW);
            intent.setClassName(this, BerufLehrerDlg.class.getName());
            startActivity(intent);
        } else {
            if (Utility.isDividable(timesStartedUp, 5) || timesStartedUp == 1
                    && checkNetworkStatus() == true) {
                if (getString("typ", "schueler").equals("schueler")) {
                    klassenListeAktualisieren(getString("klasse", ""));
                } else {
                    lehrerListeAktualisieren();
                }
            }
        }

        pullToRefreshView = (PullToRefreshListView) findViewById(R.id.pull_to_refresh_listview);
        pullToRefreshView.setOnRefreshListener(new OnRefreshListener() {
            public void onRefresh() {
                new GetDataTask().execute();
            }
        });

        loadTwitter();

        saveInt("timesStartedUp", timesStartedUp += 1);

        ShakeListener mShake = new ShakeListener(this);
        mShake.setOnShakeListener(new ShakeListener.OnShakeListener() {
            public void onShake() {
                if (getBoolean("shake", true) == true
                        && isAppOnForeground(myContext)) {
                    makeToast("Lade News...", false);
                    Log.i(TAG, "shake=true");
                    loadTwitter();
                }
            }
        });
        getListView().setDivider(null);
        getListView().setDividerHeight(0);
    }

    /**
     * Wenn in die Activity zurckgekehrt wird (Nach onPause()...)
     */
    public void onResume() {
        super.onResume();
        if (!checkNetworkStatus()) {
            loadTwitter();
        }
    }

    /**
     * Daten in Liste einfgen
     */
    private class MyCustomAdapter extends ArrayAdapter<String> implements
            View.OnCreateContextMenuListener {
        private MyCustomAdapter(Context context, int textViewResourceId,
                List<String> list, List<String> list2) {
            super(context, textViewResourceId, list);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            View row = convertView;

            if (row == null) {
                LayoutInflater inflater = getLayoutInflater();
                row = inflater.inflate(R.layout.row, parent, false);
            }

            try {
                TextView listTitle = (TextView) row.findViewById(R.id.listtitle);
                listTitle.setText(listNews.get(position).toString());
                TextView listPubdate = (TextView) row
                        .findViewById(R.id.listpubdate);
                listPubdate.setTextColor(Color.GRAY);
                listPubdate.setText(listDates.get(position).toString());
                if (getBoolean("links", false) == true) {
                    Linkify.addLinks(listTitle, Linkify.WEB_URLS);
                }
            } catch (IndexOutOfBoundsException ioobe) {

            }

            row.setOnCreateContextMenuListener(this);

            return row;
        }

        @Override
        public void onCreateContextMenu(ContextMenu arg0, View arg1,
                ContextMenuInfo arg2) {
        }
    }

    /**
     * AsyncTask fr Twitter News neu laden
     */
    private class GetDataTask extends AsyncTask<Void, Void, String> {
        @Override
        protected String doInBackground(Void... params) {
            if (checkNetworkStatus() == false) {
                makeToast(
                        "Keine Internetverbindung!\nEs werden die letzten erfolgreich geladenen News vom "
                                + getString("offlinecachelastupdate",
                                        "01.01.2011 00:00") + " angezeigt.", true);
                Log.e(TAG, "error=no_internet_connection");
                dbHelper = new NewsDbAdapter(myContext);
                dbHelper.open();
                newsCursor = dbHelper.fetchAllNews();
                startManagingCursor(newsCursor);

                String[] from = new String[] {
                        NewsDbAdapter.KEY_NEWS,
                        NewsDbAdapter.KEY_PUBDATE
                };
                int[] to = new int[] {
                        R.id.listtitle, R.id.listpubdate
                };

                registerForContextMenu(getListView());

                SimpleCursorAdapter tweets = new SimpleCursorAdapter(myContext,
                        R.layout.row, newsCursor, from, to);
                setListAdapter(tweets);
                getListView().setTextFilterEnabled(true);

                LayoutAnimationController controller = AnimationUtils
                        .loadLayoutAnimation(myContext, R.anim.list_layout_controller);
                getListView().setLayoutAnimation(controller);
                String lastUpdateOffline = getString("offlinecachelastupdate",
                        "01.01.2011 00:00").substring(
                        getString("offlinecachelastupdate", "01.01.2011 00:00")
                                .length() - 5);
                // ((PullToRefreshListView) getListView())
                // .onRefreshComplete("Letzte Aktualisierung: "
                // + lastUpdateOffline);
                // PullToRefreshListView.mRefreshViewProgress.setVisibility(View.GONE);

                pullToRefreshView.onRefreshComplete();
                pullToRefreshView.setLastUpdatedLabel("Letzte Aktualisierung: "
                        + lastUpdateOffline);

                dbHelper.close();
            } else {
                listNews.clear();
                listDates.clear();

                int requestedNews = getInt("requestedNews", 1);

                Twitter twitter = new TwitterFactory().getInstance();
                try {
                    List<twitter4j.Status> statuses;
                    String tweetcount = getString("maxtweets", "10");
                    if (tweetcount.equals("") || tweetcount.equals(null)) {
                        tweetcount = "10";
                        saveString("maxtweets", "10");
                    }
                    int anzahl = Integer.parseInt(tweetcount);
                    Paging TWEET_COUNT;
                    if (anzahl == 0) {
                        TWEET_COUNT = new Paging(1, 10);
                    } else {
                        TWEET_COUNT = new Paging(1, anzahl);
                    }

                    String username = getString("username", TWITTER_USERNAME);
                    // if (username.equals("public")) {
                    // statuses = twitter.getPublicTimeline();
                    // } else {
                    statuses = twitter.getUserTimeline(username, TWEET_COUNT);
                    // }

                    dbHelper = new NewsDbAdapter(myContext);
                    dbHelper.open();
                    dbHelper.clearTable();
                    for (twitter4j.Status status : statuses) {
                        // if (status.getText().contains("GIBM-IT")) {
                        // makeToast(getString("klasse", "") + "=" +
                        // getNameFromKlassenID(getString("klasse", "")), true);
                        listNews.add(status.getText());
                        listDates.add(status
                                .getCreatedAt()
                                .toLocaleString()
                                .substring(
                                        0,
                                        status.getCreatedAt().toLocaleString()
                                                .length() - 3));
                        /**
                         * Vor ... Minuten/Stunden/Tagen/Wochen/Monaten/Jahren
                         */
                        // listDates.add(Utility.getDateDifference(status.getCreatedAt()));
                        dbHelper.createTweet(status.getText(), status
                                .getCreatedAt().toLocaleString());
                        Log.i(TAG,
                                "tweet " + status.getId() + ": " + status.getText());
                        // }
                    }
                    dbHelper.close();
                } catch (TwitterException te) {
                    if (te.getMessage().equals("Network unreachable")) {
                        // diese error meldungen abfangen, da sie noch oft
                        // vorkommt
                        // aber nicht immer stimmt...
                    } else {
                        AlertDialog alertDialog = new AlertDialog.Builder(myContext)
                                .create();
                        alertDialog.setTitle("Fehler bei der Anfrage");
                        alertDialog.setMessage(te.getMessage());
                        alertDialog.setCancelable(false);
                        alertDialog.setButton("OK",
                                new DialogInterface.OnClickListener() {
                                    public void onClick(DialogInterface dialog,
                                            int which) {
                                    }
                                });
                        Log.w(TAG, "isShowing=" + alertDialog.isShowing());
                        if (alertDialog.isShowing()) {
                            // do nothing...
                        } else {
                            alertDialog.show();
                        }
                        Log.e(TAG, "twitter4j error: " + te.getMessage());
                    }
                }
            }
            return "";
        }

        @Override
        protected void onPostExecute(String result) {
            loadTwitter();

            super.onPostExecute(result);
        }
    }

    /**
     * Trackball deaktivieren
     */
    @Override
    public boolean onTrackballEvent(MotionEvent motionEvent) {
        int action = motionEvent.getAction();
        if (action == MotionEvent.ACTION_MOVE) {
            return true;
        }
        return true;
    }

    /**
     * Wenn die Activity geschlossen wurde
     */
    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (dbHelper != null) {
            dbHelper.close();
        }
    }

    /**
     * Ldt die News mit Hilfe von Twitter4J in die Liste oder wenn keine
     * Internetverbindung besteht aus dem Offline Cache in die Liste
     */
    @SuppressWarnings("deprecation")
    private void loadTwitter() {
        if (checkNetworkStatus() == false) {
            makeToast(
                    "Keine Internetverbindung!\nEs werden die letzten erfolgreich geladenen News vom "
                            + getString("offlinecachelastupdate",
                                    "01.01.2011 00:00") + " angezeigt.", true);
            Log.e(TAG, "error=no_internet_connection");
            dbHelper = new NewsDbAdapter(this);
            dbHelper.open();
            newsCursor = dbHelper.fetchAllNews();
            startManagingCursor(newsCursor);

            String[] from = new String[] {
                    NewsDbAdapter.KEY_NEWS,
                    NewsDbAdapter.KEY_PUBDATE
            };
            int[] to = new int[] {
                    R.id.listtitle, R.id.listpubdate
            };

            registerForContextMenu(getListView());

            SimpleCursorAdapter tweets = new SimpleCursorAdapter(this,
                    R.layout.row, newsCursor, from, to);
            setListAdapter(tweets);
            getListView().setTextFilterEnabled(true);

            LayoutAnimationController controller = AnimationUtils
                    .loadLayoutAnimation(this, R.anim.list_layout_controller);
            getListView().setLayoutAnimation(controller);
            String lastUpdateOffline = getString("offlinecachelastupdate",
                    "01.01.2011 00:00").substring(
                    getString("offlinecachelastupdate", "01.01.2011 00:00")
                            .length() - 5);
            // ((PullToRefreshListView) getListView())
            // .onRefreshComplete("Letzte Aktualisierung: "
            // + lastUpdateOffline);
            // PullToRefreshListView.mRefreshViewProgress.setVisibility(View.GONE);

            pullToRefreshView.onRefreshComplete();
            pullToRefreshView.setLastUpdatedLabel("Letzte Aktualisierung: "
                    + lastUpdateOffline);

            dbHelper.close();
        } else {
            listNews.clear();
            listDates.clear();

            int requestedNews = getInt("requestedNews", 1);

            Twitter twitter = new TwitterFactory().getInstance();
            try {
                List<Status> statuses;
                String tweetcount = getString("maxtweets", "10");
                if (tweetcount.equals("") || tweetcount.equals(null)) {
                    tweetcount = "10";
                    saveString("maxtweets", "10");
                }
                int anzahl = Integer.parseInt(tweetcount);
                Paging TWEET_COUNT;
                if (anzahl == 0) {
                    TWEET_COUNT = new Paging(1, 10);
                } else {
                    TWEET_COUNT = new Paging(1, anzahl);
                }

                String username = getString("username", TWITTER_USERNAME);
                // if (username.equals("public")) {
                // statuses = twitter.getPublicTimeline();
                // } else {
                statuses = twitter.getUserTimeline(username, TWEET_COUNT);
                // }

                dbHelper = new NewsDbAdapter(this);
                dbHelper.open();
                dbHelper.clearTable();
                for (Status status : statuses) {
                    // if (status.getText().contains("GIBM-IT")) {
                    // makeToast(getString("klasse", "") + "=" +
                    // getNameFromKlassenID(getString("klasse", "")), true);
                    listNews.add(status.getText());
                    listDates.add(status
                            .getCreatedAt()
                            .toLocaleString()
                            .substring(
                                    0,
                                    status.getCreatedAt().toLocaleString()
                                            .length() - 3));
                    /**
                     * Vor ... Minuten/Stunden/Tagen/Wochen/Monaten/Jahren
                     */
                    // listDates.add(Utility.getDateDifference(status.getCreatedAt()));
                    dbHelper.createTweet(status.getText(), status
                            .getCreatedAt().toLocaleString());
                    Log.i(TAG,
                            "tweet " + status.getId() + ": " + status.getText());
                    // }
                }
                dbHelper.close();
            } catch (TwitterException te) {
                if (te.getMessage().equals("Network unreachable")) {
                    // diese error meldungen abfangen, da sie noch oft vorkommt
                    // aber nicht immer stimmt...
                } else {
                    AlertDialog alertDialog = new AlertDialog.Builder(this)
                            .create();
                    alertDialog.setTitle("Fehler bei der Anfrage");
                    alertDialog.setMessage(te.getMessage());
                    alertDialog.setCancelable(false);
                    alertDialog.setButton("OK",
                            new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog,
                                        int which) {
                                }
                            });
                    Log.w(TAG, "isShowing=" + alertDialog.isShowing());
                    if (alertDialog.isShowing()) {
                        // do nothing...
                    } else {
                        alertDialog.show();
                    }
                    Log.e(TAG, "twitter4j error: " + te.getMessage());
                }
            }

            MyCustomAdapter myAdapter = new MyCustomAdapter(this, R.layout.row,
                    listNews, listDates);
            setListAdapter(myAdapter);
            myAdapter.notifyDataSetChanged();
            getListView().setTextFilterEnabled(true);

            LayoutAnimationController controller = AnimationUtils
                    .loadLayoutAnimation(this, R.anim.list_layout_controller);
            getListView().setLayoutAnimation(controller);
            registerForContextMenu(getListView());
            saveInt("requestedNews", requestedNews += 1);
            Date d = new Date();
            String lastUpdate = (new SimpleDateFormat("HH:mm")).format(d);
            String offlineCacheLastUpdate = (new SimpleDateFormat(
                    "dd.MM.yyyy HH:mm")).format(d);
            // ((PullToRefreshListView) getListView())
            // .onRefreshComplete("Letzte Aktualisierung: " + lastUpdate);
            Log.i(TAG, "offlineCacheLastUpdate=" + offlineCacheLastUpdate);
            saveString("offlinecachelastupdate", offlineCacheLastUpdate);
            // PullToRefreshListView.mRefreshViewProgress.setVisibility(View.GONE);

            pullToRefreshView.onRefreshComplete();
            pullToRefreshView.setLastUpdatedLabel("Letzte Aktualisierung: " + lastUpdate);
        }
    }

    /**
     * Aktualisiert die Liste aller Klassen in einem bestimmten Beruf und
     * speichert sie in einer Datenbank
     * 
     * @param berufsId
     */
    private void klassenListeAktualisieren(String berufsId) {
        try {
            HttpClient client = new DefaultHttpClient();
            HttpGet method = new HttpGet(
                    "http://home.gibm.ch/interfaces/gibmapp/klassenliste.php?beruf="
                            + berufsId);
            client.execute(method);
            URL twitter = new URL(
                    "http://home.gibm.ch/interfaces/gibmapp/klassenliste.json");
            URLConnection tc = twitter.openConnection();
            BufferedReader in = new BufferedReader(new InputStreamReader(
                    tc.getInputStream()));

            dbHelperKlasse = new KlassenlisteDbAdapter(myContext);
            dbHelperKlasse.open();
            dbHelperKlasse.clearTable();

            String line;
            while ((line = in.readLine()) != null) {
                JSONArray ja = new JSONArray(line);

                for (int i = 0; i < ja.length(); i++) {
                    JSONObject jo = (JSONObject) ja.get(i);
                    dbHelperKlasse.createKlasse(jo.getString("klasse_id"),
                            jo.getString("klassekuerzel"));
                }
            }
            dbHelperKlasse.close();
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    /**
     * Ldt die komplette Liste aller Lehrer der Schule und speichert sie in
     * einer Datenbank
     */
    private void lehrerListeAktualisieren() {
        try {
            HttpClient client = new DefaultHttpClient();
            HttpGet method = new HttpGet(
                    "http://home.gibm.ch/interfaces/gibmapp/lehrerliste.php");
            client.execute(method);
            URL twitter = new URL(
                    "http://home.gibm.ch/interfaces/gibmapp/lehrerliste.json");
            URLConnection tc = twitter.openConnection();
            BufferedReader in = new BufferedReader(new InputStreamReader(
                    tc.getInputStream()));

            dbHelperLehrer = new LehrerlisteDbAdapter(myContext);
            dbHelperLehrer.open();
            dbHelperLehrer.clearTable();

            String line;
            while ((line = in.readLine()) != null) {
                JSONArray ja = new JSONArray(line);

                for (int i = 0; i < ja.length(); i++) {
                    JSONObject jo = (JSONObject) ja.get(i);
                    dbHelperLehrer.createLehrer(jo.getString("lehrer_id"),
                            jo.getString("lehrer_name"));
                }
            }
            dbHelperLehrer.close();
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    /**
     * Optionsmenu erzeugen
     */
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.listmenu, menu);
        Log.i(TAG, "optionsmenu=true");
        return true;
    }

    /**
     * Auswertung der ausgewhlten Menueintrge
     */
    @Override
    public boolean onMenuItemSelected(int featureId, MenuItem item) {
        switch (item.getItemId()) {
            case R.id.stundenplan:
                String klassePrefs = getString("klasse", "");
                if (klassePrefs.equals(null) || klassePrefs.equals("")) {
                    makeToast(
                            "Bitte in den Einstellungen zuerst eine Klasse auswhlen.",
                            true);
                    Log.e(TAG, "error=no_school_class_selected");
                } else if (!checkNetworkStatus()) {
                    makeToast(
                            "Keine Internetverbindung!\nDer Stundenplan kann nur mit Internetverbindung abgerufen werden",
                            true);
                    Log.e(TAG, "error=no_internet_connection");
                } else {
                    Intent myIntents = new Intent(this, Stundenplan.class);
                    Log.i(TAG, "stundenplan=true");
                    startActivityForResult(myIntents, STUNDENPLAN_REQUEST_CODE);
                }
                return true;
            case R.id.agenda:
                showAgenda();
                return true;
            case R.id.settings:
                Intent myIntent = new Intent(this, Settings.class);
                Log.i(TAG, "settings=true");
                startActivityForResult(myIntent, SETTINGS_REQUEST_CODE);
                return true;
            case R.id.exit:
                Log.i(TAG, "exit");
                PushManager.stopService();
                finish();
                return true;
        }
        return super.onMenuItemSelected(featureId, item);
    }

    /**
     * Zeige die GIBM Agenda
     */
    private void showAgenda() {
        Agenda agenda = new Agenda();
        agenda.onPreExecute(myContext);
        agenda.execute();
    }

    /**
     * Contextmenu erzeugen
     */
    @Override
    public void onCreateContextMenu(ContextMenu menu, View v,
            ContextMenuInfo menuInfo) {
        super.onCreateContextMenu(menu, v, menuInfo);

        menu.setHeaderTitle("GIBM IT News");
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.contextmenu, menu);
        Log.i(TAG, "contextmenu=true");
    }

    /**
     * Auswertung der Contextmenu Eintrge
     */
    @SuppressWarnings("deprecation")
    @Override
    public boolean onContextItemSelected(MenuItem item) {
        AdapterContextMenuInfo info = (AdapterContextMenuInfo) item
                .getMenuInfo();
        String derTweetText = getListAdapter().getItem(info.position - 1)
                .toString();

        if (item.getItemId() == R.id.item1) {
            final ClipboardManager clipBoard = (ClipboardManager) getSystemService(CLIPBOARD_SERVICE);
            clipBoard.setText(derTweetText);
            makeToast("News kopiert", false);
            Log.i(TAG, "clipboard text=" + derTweetText);
            return true;
        } else if (item.getItemId() == R.id.item2) {
            Intent shareIntent = new Intent(android.content.Intent.ACTION_SEND);
            shareIntent.setType("text/plain");
            shareIntent.putExtra(android.content.Intent.EXTRA_SUBJECT,
                    "GIBM IT News");
            shareIntent.putExtra(android.content.Intent.EXTRA_TEXT,
                    derTweetText);
            Log.i(TAG, "share text=" + derTweetText);
            startActivity(Intent.createChooser(shareIntent, "Teilen"));
            return true;
        } else {
            return super.onContextItemSelected(item);
        }
    }

    /**
     * Auswertung nach der Rckkehr von einer anderen Activity
     */
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (resultCode) {
            case SETTINGS_REQUEST_CODE:
                setAlarms();
                break;
            case SETTINGS_REQUEST_CODE_ENABLELINKS:
                setAlarms();
                loadTwitter();
                break;
        }
    }

    /**
     * Setzt alle ntigen Alarme, um die Erinnerungen auszulsen
     */
    private void setAlarms() {
        AlarmService as = new AlarmService(myContext);
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(myContext);
        Date jetzt = new Date();
        java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat("HH:mm");
        String ausgabe = sdf.format(jetzt);
        int prefsHrs = Utility.getHour(app_preferences.getString("time",
                "20:00"));
        int prefsMin = Utility.getMinutes(app_preferences.getString("time",
                "20:00"));
        int jetztHrs = Utility.getHour(ausgabe);
        int jetztMin = Utility.getMinutes(ausgabe);

        String strJetztHrs = String.valueOf(jetztHrs);
        String strjetztMin = String.valueOf(jetztMin);
        String strprefsHrs = String.valueOf(prefsHrs);
        String strprefsMin = String.valueOf(prefsMin);

        if (String.valueOf(jetztHrs).length() == 1) {
            strJetztHrs = "0" + String.valueOf(jetztHrs);
        }
        if (String.valueOf(jetztMin).length() == 1) {
            strjetztMin = "0" + String.valueOf(jetztMin);
        }
        if (String.valueOf(prefsHrs).length() == 1) {
            strprefsHrs = "0" + String.valueOf(prefsHrs);
        }
        if (String.valueOf(prefsMin).length() == 1) {
            strprefsMin = "0" + String.valueOf(prefsMin);
        }

        String strResultJetzt = strJetztHrs + strjetztMin;
        String strResultPrefs = strprefsHrs + strprefsMin;

        if (Integer.parseInt(strResultJetzt) > Integer.parseInt(strResultPrefs)) {
            as.setRepeatAlarm(Utility.getHour(app_preferences.getString("time",
                    "20:00")), Utility.getMinutes(app_preferences.getString(
                    "time", "20:00")), true);
        } else if (Integer.parseInt(strResultJetzt) < Integer
                .parseInt(strResultPrefs)) {
            as.setRepeatAlarm(Utility.getHour(app_preferences.getString("time",
                    "20:00")), Utility.getMinutes(app_preferences.getString(
                    "time", "20:00")), false);
        }
        Log.i(TAG, "settings=false");
    }

    /**
     * Fragt einen string aus den Shared Preferences ab
     * 
     * @param keyName
     * @param value
     * @return wert des gegebenen keys
     */
    private String getString(String keyName, String value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);

        String variable = app_preferences.getString(keyName, value);

        Log.i(TAG, "mode=get type=string defaultvalue=" + value + " key="
                + keyName + " returned=" + variable);
        return variable;
    }

    /**
     * Speichert einen string in die Shared Preferences
     * 
     * @param keyName
     * @param value
     */
    private void saveString(String keyName, String value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);
        SharedPreferences.Editor pref_editor = app_preferences.edit();

        Log.i(TAG, "mode=save type=string value=" + value + " key=" + keyName);

        pref_editor.putString(keyName, value);
        pref_editor.commit();
    }

    /**
     * Fragt einen integer aus den Shared Preferences ab
     * 
     * @param keyName
     * @param value
     * @return wert des gegebenen keys
     */
    private int getInt(String keyName, int value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);

        int variable = app_preferences.getInt(keyName, value);

        Log.i(TAG, "mode=get type=integer defaultvalue=" + value + " key="
                + keyName + " returned=" + variable);
        return variable;
    }

    /**
     * Speichert einen integer in die Shared Preferences
     * 
     * @param keyName
     * @param value
     */
    private void saveInt(String keyName, int value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);
        SharedPreferences.Editor pref_editor = app_preferences.edit();

        Log.i(TAG, "mode=save type=integer value=" + value + " key=" + keyName);

        pref_editor.putInt(keyName, value);
        pref_editor.commit();
    }

    /**
     * Fragt einen boolean aus den Shared Preferences ab
     * 
     * @param keyName
     * @param value
     * @return wahr oder falsch
     */
    private boolean getBoolean(String keyName, boolean value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);

        boolean variable = app_preferences.getBoolean(keyName, value);

        Log.i(TAG, "mode=get type=boolean defaultvalue=" + value + " key="
                + keyName + " returned=" + variable);
        return variable;
    }

    /**
     * Prft ob eine Verbindung zum Internet besteht
     * 
     * @return wahr oder falsch
     */
    private boolean checkNetworkStatus() {
        final ConnectivityManager connMgr = (ConnectivityManager) this
                .getSystemService(Context.CONNECTIVITY_SERVICE);
        final android.net.NetworkInfo wifi = connMgr
                .getNetworkInfo(ConnectivityManager.TYPE_WIFI);
        final android.net.NetworkInfo mobile = connMgr
                .getNetworkInfo(ConnectivityManager.TYPE_MOBILE);

        if (wifi.isConnected()) {
            Log.i(TAG, "connection=wlan");
            return true;
        } else if (mobile.isConnected()) {
            Log.i(TAG, "connection=mobile");
            return true;
        } else {
            Log.i(TAG, "connection=no_connection");
            return false;
        }
    }

    /**
     * Erstellt eine Toast Nachricht mit dem gegebenen Text
     * 
     * @param message
     * @param lengthlong
     */
    private void makeToast(String message, boolean lengthlong) {
        Context context = getApplicationContext();
        CharSequence text = message;
        int duration;

        if (lengthlong == true) {
            duration = Toast.LENGTH_LONG;
        } else {
            duration = Toast.LENGTH_SHORT;
        }

        Log.i(TAG, "toast titel=" + message + " length_long=" + lengthlong);

        Toast toast = Toast.makeText(context, text, duration);
        toast.show();
    }

    /**
     * Prft ob die App im Vordergrund ist
     * 
     * @param context
     * @return wahr oder falsch
     */
    private boolean isAppOnForeground(Context context) {
        ActivityManager activityManager = (ActivityManager) context
                .getSystemService(Context.ACTIVITY_SERVICE);
        List<RunningAppProcessInfo> appProcesses = activityManager
                .getRunningAppProcesses();
        if (appProcesses == null) {
            Log.i(TAG, "foreground=false");
            return false;
        }
        final String packageName = context.getPackageName();
        for (RunningAppProcessInfo appProcess : appProcesses) {
            if (appProcess.importance == RunningAppProcessInfo.IMPORTANCE_FOREGROUND
                    && appProcess.processName.equals(packageName)) {
                Log.i(TAG, "foreground=true");
                return true;
            }
        }
        return false;
    }

    /**
     * Prft ob Wavesecure im Hintergrund einen Prozess laufen hat
     * 
     * @return wahr oder falsch
     */
    private boolean isWavesecureRunning() {
        ActivityManager activityManager = (ActivityManager) this
                .getSystemService(ACTIVITY_SERVICE);
        List<RunningAppProcessInfo> procInfos = activityManager
                .getRunningAppProcesses();
        for (int i = 0; i < procInfos.size();) {
            if (procInfos.get(i).processName.equals("com.wsandroid.suite")) {
                Log.i(TAG, "wavesecurerunning=true");
                return true;
            } else {
                Log.i(TAG, "wavesecurerunning=false");
                return false;
            }
        }
        return false;
    }

    /**
     * Zeigt einen Dialog an, falls Wavesecure luft (Wegen Vibrationsbug)
     */
    private void showWavesecureDialog() {
        DialogInterface.OnClickListener dialogClickListeners = new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                switch (which) {
                    case DialogInterface.BUTTON_POSITIVE:
                        saveInt("wavesecure", 2);
                        break;
                }
            }
        };

        AlertDialog.Builder builder = new AlertDialog.Builder(myContext);
        builder.setTitle("McAfee Wavesecure");
        builder.setCancelable(false);
        builder.setMessage(
                "McAfee Wavesecure wurde entdeckt.\nDa in der Wavesecure App ein Fehler programmiert wurde, welcher die Wavesecure App abstrzen lsst, wird bei den Erinnerungen unter Umstnden eine unendlich lange Vibration ausgelst.")
                .setPositiveButton("OK", dialogClickListeners).show();
    }

    /**
     * Prft ob Google Talk im Hintergrund einen Prozess laufen hat
     * 
     * @return wahr oder falsch
     */
    public boolean isGTalkRunning() {
        ActivityManager actvityManager = (ActivityManager) this
                .getSystemService(ACTIVITY_SERVICE);
        List<RunningAppProcessInfo> procInfos = actvityManager
                .getRunningAppProcesses();
        for (int i = 0; i < procInfos.size(); i++) {
            if (procInfos.get(i).processName.equals("com.google.android.talk")) {
                return true;
            }
        }
        return false;
    }

    /**
     * Zeigt einen Dialog an, falls Google Talk luft (Da es mit dem Push
     * Probleme gibt)
     */
    private void showTalkDialog() {
        DialogInterface.OnClickListener dialogClickListeners = new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                switch (which) {
                    case DialogInterface.BUTTON_POSITIVE:
                        // nothing...
                        break;
                    case DialogInterface.BUTTON_NEGATIVE:
                        saveInt("gtalk", 2);
                        break;
                }
            }
        };

        AlertDialog.Builder builder = new AlertDialog.Builder(myContext);
        builder.setTitle("Google Talk");
        builder.setCancelable(false);
        builder.setMessage(
                "Google Talk ist geffnet. Diese App blockiert die Push Nachrichten der GIBM App, sodass diese nicht auf dem Gert ankommen. Falls Sie Push verwenden mchten sollten Sie Google Talk deinstallieren oder sich abmelden und die Google Talk schliessen.")
                .setPositiveButton("OK", dialogClickListeners)
                .setNegativeButton("Nicht mehr zeigen", dialogClickListeners)
                .show();
    }
}
