
package com.tizianhoesch.gibmitnews;

import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.os.Bundle;
import android.preference.CheckBoxPreference;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;
import android.util.Log;

import com.tizianhoesch.gibmitnews.tools.BerufLehrerDlg;
import com.urbanairship.push.PushManager;
import com.urbanairship.push.PushPreferences;

public class Settings extends PreferenceActivity implements
        OnSharedPreferenceChangeListener {
    private boolean zeigeLinksChanged = false;
    private boolean stillTheSame;
    private boolean stillTheSame2;
    // private boolean stillTheSame3;
    CheckBoxPreference chkLinks;
    CheckBoxPreference chkPush;
    // SwitchPreference chkLinksS;
    PushPreferences prefs = PushManager.shared().getPreferences();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setTitle(getString(R.string.app_name));

        // int SDK_INT = android.os.Build.VERSION.SDK_INT;

        // if (SDK_INT >= 14) {
        // getFragmentManager().beginTransaction()
        // .replace(android.R.id.content, new PrefsFragment())
        // .commit();
        // } else {
        addPreferencesFromResource(R.xml.preferences);

        stillTheSame = getBoolean("links", false);
        stillTheSame2 = getBoolean("enablepush", true);
        // stillTheSame3 = getBoolean("links", false);
        chkLinks = (CheckBoxPreference) findPreference("links");
        chkPush = (CheckBoxPreference) findPreference("enablepush");

        Preference clKlassen = (Preference) findPreference("klasse");
        clKlassen.setIntent(new Intent(this, BerufLehrerDlg.class));
        // }
    }

    /**
     * Wird nach onPause() aufgerufen
     */
    @Override
    protected void onResume() {
        super.onResume();
        // getPreferenceScreen().getSharedPreferences()
        // .registerOnSharedPreferenceChangeListener(this);
    }

    /**
     * Wenn die Zurck Taste gedrckt wird
     */
    @Override
    public void onBackPressed() {
        if (zeigeLinksChanged == true) {
            if (chkLinks.isChecked() == stillTheSame) {
                // || chkLinksS.isChecked() == stillTheSame3) {
                setResult(GIBMITNewsActivity.SETTINGS_REQUEST_CODE);
            } else {
                setResult(GIBMITNewsActivity.SETTINGS_REQUEST_CODE_ENABLELINKS);
            }
            finish();
        } else {
            setResult(GIBMITNewsActivity.SETTINGS_REQUEST_CODE);
            finish();
        }
        if (chkPush.isChecked() == stillTheSame2) {
            // nothing...
        } else {
            if (chkPush.isChecked()) {
                PushManager.enablePush();
            } else {
                PushManager.disablePush();
            }
        }
        return;
    }

    /**
     * Die Shared Preferences haben sich gendert
     */
    @Override
    public void onSharedPreferenceChanged(SharedPreferences sharedPrefs,
            String key) {
        if (key.equals("links")) {
            zeigeLinksChanged = true;
        }
    }

    /**
     * Holt einen Boolean aus den Default Shared Preferences
     * 
     * @param keyName
     * @param value
     * @return wahr oder falsch
     */
    private boolean getBoolean(String keyName, boolean value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);

        boolean variable = app_preferences.getBoolean(keyName, value);

        Log.i(GIBMITNewsActivity.TAG, "mode=get type=boolean defaultvalue="
                + value + " key=" + keyName + " returned=" + variable);
        return variable;
    }

    // public class PrefsFragment extends PreferenceFragment {
    //
    // @Override
    // public void onCreate(Bundle savedInstanceState) {
    // super.onCreate(savedInstanceState);
    //
    // addPreferencesFromResource(R.xml.preferences_new);
    // stillTheSame = getBoolean("links", false);
    // stillTheSame2 = getBoolean("enablepush", true);
    // chkLinksS = (SwitchPreference) findPreference("links");
    // chkPush = (CheckBoxPreference) findPreference("enablepush");
    // }
    // }
}
