
package com.tizianhoesch.gibmitnews;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.webkit.WebView;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashMap;

public class Stundenplan extends Activity implements OnClickListener {
    private final Context myContext = this;
    private String htmlWithCss = "";
    private WebView StundenPlanWebView;
    private ProgressDialog dialog;
    private TextView txtWeek;
    int aktuelleWoche;
    int aktuellesJahr;
    ImageButton btnBack;
    ImageButton btnForward;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.stundenplan);

        txtWeek = (TextView) findViewById(R.id.textViewWoche);

        aktuelleWoche = new GregorianCalendar().get(Calendar.WEEK_OF_YEAR);
        aktuellesJahr = new GregorianCalendar().get(Calendar.YEAR);

        txtWeek.setText("    Woche " + aktuelleWoche + ", " + aktuellesJahr
                + "    ");

        btnBack = (ImageButton) findViewById(R.id.btnWeekBack);
        btnForward = (ImageButton) findViewById(R.id.btnWeekForward);

        btnBack.setOnClickListener(this);
        btnForward.setOnClickListener(this);

        StundenPlanWebView = (WebView) findViewById(R.id.StundenPlanWebView);
        new StundenPlanDownloader().execute();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.export, menu);
        return true;
    }

    @Override
    public boolean onMenuItemSelected(int featureId, MenuItem item) {
        switch (item.getItemId()) {
            case R.id.export:
                String berufId = getString("beruf", "");
                String klassePrefs = getString("klasse", "");
                String typeOfSchool = getString("typ", "");
                // StundenPlanWebView
                // .loadUrl("http://home.gibm.ch/export_stundenplan.php?id=38&popup=stundenplan&beruf=10&klasse=1230758&lehrer=&woche=33-2012");

                new DownloadICSOfStundenplan().execute();

                // if (typeOfSchool.equals("schueler")) {
                // StundenPlanWebView.loadUrl(
                // "http://home.gibm.ch/export_stundenplan.php?id=38&popup=stundenplan&beruf="
                // + berufId + "&klasse=" + klassePrefs
                // + "&lehrer=&woche=" + aktuelleWoche + "-"
                // + aktuellesJahr);
                // Log.e("GIBMITNEWS", "isSchueler=true");
                // Log.e("GIBMITNEWS",
                // "http://home.gibm.ch/export_stundenplan.php?id=38&popup=stundenplan&beruf="
                // + berufId + "&klasse=" + klassePrefs
                // + "&lehrer=&woche=" + aktuelleWoche + "-"
                // + aktuellesJahr);
                // } else if (typeOfSchool.equals("lehrer")) {
                // StundenPlanWebView.loadUrl(
                // "http://home.gibm.ch/export_stundenplan.php?id=38&popup=stundenplan&lehrer="
                // + klassePrefs + "&woche=" + aktuelleWoche + "-"
                // + aktuellesJahr);
                // Log.e("GIBMITNEWS", "isSchueler=false");
                // Log.e("GIBMITNEWS",
                // "http://home.gibm.ch/export_stundenplan.php?id=38&popup=stundenplan&lehrer="
                // + klassePrefs + "&woche=" + aktuelleWoche + "-"
                // + aktuellesJahr);
                // }

                return true;
        }
        return super.onMenuItemSelected(featureId, item);
    }

    /**
     * Ldt das ICS File zum aktuell angezeigten Stundenplan auf das Smartphone
     * und startet es danach um es zu importieren.
     */
    class DownloadICSOfStundenplan extends AsyncTask<Void, Void, Void> {
        ArrayList<HashMap<String, String>> eventsList = new ArrayList<HashMap<String, String>>();

        protected Void doInBackground(Void... args) {
            String berufId = getString("beruf", "");
            String klassePrefs = getString("klasse", "");
            String typeOfSchool = getString("typ", "");

            try {
                URL url = new URL(
                        "http://home.gibm.ch/export_stundenplan.php?id=38&popup=stundenplan&beruf="
                                + berufId + "&klasse=" + klassePrefs
                                + "&lehrer=&woche=" + aktuelleWoche + "-"
                                + aktuellesJahr);
                HttpURLConnection c = (HttpURLConnection) url.openConnection();
                c.setRequestMethod("GET");
                c.setDoOutput(true);
                c.connect();

                String PATH = Environment.getExternalStorageDirectory()
                        + "/download/";
                File file = new File(PATH);
                file.mkdirs();

                String fileName = "Stundenplan.ics";

                File outputFile = new File(file, fileName);
                FileOutputStream fos = new FileOutputStream(outputFile);

                InputStream is = c.getInputStream();

                byte[] buffer = new byte[1024];
                int len1 = 0;
                while ((len1 = is.read(buffer)) != -1) {

                    fos.write(buffer, 0, len1);

                }
                fos.close();
                is.close();

                // }
            } catch (IOException e) {
                Toast.makeText(Stundenplan.this, "error " + e.toString(), Toast.LENGTH_LONG)
                        .show();

            }
            return null;
        }

        protected void onPreExecute() {
            if (dialog == null || !dialog.isShowing()) {
                dialog = ProgressDialog.show(myContext, null,
                        "Stundenplan wird heruntergeladen...", true, false,
                        new OnCancelListener() {
                            @Override
                            public void onCancel(DialogInterface dialog) {
                                finish();
                            }
                        }
                        );
            }
        }

        protected void onPostExecute(Void result) {
            dialog.dismiss();

            Intent intent = new Intent();
            intent.setAction(android.content.Intent.ACTION_VIEW);
            File file = new File(Environment.getExternalStorageDirectory()
                    + "/download/Stundenplan.ics");
            intent.setDataAndType(Uri.fromFile(file), "text/*");
            startActivity(intent);

            super.onPostExecute(result);
        }
    }

    /**
     * Ladet den Stundenplan asynchron mit einem Dialog welcher angezeigt wird.
     */
    private class StundenPlanDownloader extends AsyncTask<Void, Void, String> {

        public StundenPlanDownloader() {
        }

        @Override
        public void onPreExecute() {
            super.onPreExecute();
            dialog = new ProgressDialog(myContext);
            dialog.setMessage("Der Stundenplan wird geladen...");
            dialog.setCancelable(false);
            dialog.setCanceledOnTouchOutside(false);
            dialog.show();
        }

        @Override
        public void onPostExecute(String unused) {
            txtWeek.setText("    Woche " + aktuelleWoche + ", " + aktuellesJahr
                    + "    ");
            StundenPlanWebView.loadDataWithBaseURL(null, htmlWithCss,
                    "text/html", "utf-8", null);
            dialog.dismiss();
            int scale = getInt("webScale", 200);
            StundenPlanWebView.setInitialScale(scale);
        }

        @Override
        protected String doInBackground(Void... params) {
            String berufId = getString("beruf", "");
            String klassePrefs = getString("klasse", "");
            String typeOfSchool = getString("typ", "");

            HttpGet request = null;

            StundenPlanWebView.setClickable(true);
            StundenPlanWebView.setInitialScale(200);
            StundenPlanWebView.setVerticalScrollBarEnabled(true);
            StundenPlanWebView.setHorizontalScrollBarEnabled(true);
            StundenPlanWebView.getSettings().setJavaScriptEnabled(true);
            StundenPlanWebView.getSettings().setBuiltInZoomControls(true);

            HttpClient client = new DefaultHttpClient();
            if (typeOfSchool.equals("schueler")) {
                request = new HttpGet(
                        "http://home.gibm.ch/index.php?id=38&popup=stundenplan&beruf="
                                + berufId + "&klasse=" + klassePrefs
                                + "&lehrer=&woche=" + aktuelleWoche + "-"
                                + aktuellesJahr + "&print=1");
            } else if (typeOfSchool.equals("lehrer")) {
                request = new HttpGet(
                        "http://home.gibm.ch/index.php?id=38&popup=stundenplan&lehrer="
                                + klassePrefs + "&woche=" + aktuelleWoche + "-"
                                + aktuellesJahr + "&print=1");
            }

            HttpResponse response = null;
            try {
                response = client.execute(request);
            } catch (ClientProtocolException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }

            String myCSS = "table.spTable {"
                    + "border-left:1px solid #000000;\n" + "}"
                    + "td.spColumn {" + "border-right:1px solid #000000;\n"
                    + "vertical-align:top;\n" + "}" + "div.spSpacer {"
                    + "width:160px;\n" + "background-color:transparent;\n"
                    + "border-bottom:0;\n" + "padding:0;\n" + "margin:0;\n"
                    + "border-top:1px solid #000000;\n" + "padding-left:4px;\n"
                    + "overflow-x: hidden;\n" + "overflow-y: hidden;\n" + "}"
                    + "div.spLesson {" + "width:160px;\n"
                    + "background-color:#D9E6F0;\n" + "border-bottom:0;\n"
                    + "border-top:1px solid #000000;\n" + "padding:0;\n"
                    + "margin:0;\n" + "font-size:10px;\n"
                    + "padding-left:4px;\n" + "overflow-x: hidden;\n"
                    + "overflow-y: hidden;\n" + "height: auto;\n" + "}"
                    + "div.spTitle {" + "padding:0;\n" + "margin: 0;\n"
                    + "height: 20px;\n" + "background-color:transparent;\n"
                    + "border-bottom:none;\n" + "font-size:13px;\n"
                    + "font-weight:bold;\n" + "padding-left:4px;\n"
                    + "margin-bottom:10px;\n" + "width:160px;\n" + "}"
                    + "div.spTitleCrossover {" + "padding:0;\n"
                    + "margin: 0;\n" + "height: 20px;\n"
                    + "background-color:#F4EFE2;\n" + "border-bottom:none;\n"
                    + "font-size:13px;\n" + "font-weight:bold;\n"
                    + "padding-left:4px;\n" + "margin-bottom:10px;\n"
                    + "width:161px;\n" + "margin-left:-1px;\n"
                    + "position:relative;\n" + "}" + "div.week {"
                    + "background-color:#D9E6F0;\n" + "width:180px;\n"
                    + "padding:4px;\n" + "margin:0;\n"
                    + "border:1px solid #000000;\n" + "font-size:14px;\n"
                    + "text-align: center;\n" + "}";

            String html = "";
            InputStream in = new ByteArrayInputStream("FEHLER".getBytes());
            try {
                in = response.getEntity().getContent();
            } catch (IllegalStateException e1) {
                e1.printStackTrace();
            } catch (IOException e1) {
                e1.printStackTrace();
            }
            BufferedReader reader = null;
            try {
                reader = new BufferedReader(new InputStreamReader(in,
                        "windows-1252"));
            } catch (UnsupportedEncodingException e1) {
                e1.printStackTrace();
            }
            StringBuilder str = new StringBuilder();
            String line = null;
            try {
                while ((line = reader.readLine()) != null) {
                    str.append(line);
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                in.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            int gefunden = str.toString().indexOf("window.print()");
            int gefunden2 = str.toString().indexOf("<br><br>");
            html = str.toString().substring(gefunden - 30, gefunden2);
            htmlWithCss = "<html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\"/><style type=\"text/css\">"
                    + myCSS + "</style></head><body>" + html + "</body></html>";
            return htmlWithCss;
        }
    }

    public boolean onKeyDown(int keyCode, KeyEvent event) {
        saveInt("webScale", (int) StundenPlanWebView.getScale() * 100);
        return super.onKeyDown(keyCode, event);
    }

    public void onPause() {
        super.onPause();
        if (dialog.isShowing()) {
            dialog.dismiss();
        }
    }

    /**
     * Fragt einen String aus den Shared Preferences ab
     * 
     * @param keyName
     * @param value
     * @return den String
     */
    private String getString(String keyName, String value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);

        String variable = app_preferences.getString(keyName, value);

        Log.i(GIBMITNewsActivity.TAG, "mode=get type=string defaultvalue="
                + value + " key=" + keyName + " returned=" + variable);

        return variable;
    }

    /**
     * Fragt einen integer aus den Shared Preferences ab
     * 
     * @param keyName
     * @param value
     * @return wert des gegebenen keys
     */
    private int getInt(String keyName, int value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);

        int variable = app_preferences.getInt(keyName, value);

        Log.i(GIBMITNewsActivity.TAG, "mode=get type=integer defaultvalue="
                + value + " key=" + keyName + " returned=" + variable);
        return variable;
    }

    /**
     * Speichert einen integer in die Shared Preferences
     * 
     * @param keyName
     * @param value
     */
    private void saveInt(String keyName, int value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);
        SharedPreferences.Editor pref_editor = app_preferences.edit();

        Log.i(GIBMITNewsActivity.TAG, "mode=save type=integer value=" + value
                + " key=" + keyName);

        pref_editor.putInt(keyName, value);
        pref_editor.commit();
    }

    @Override
    public void onClick(View v) {
        if (v == btnBack) {
            if (aktuelleWoche == 1) {
                aktuelleWoche = 52;
                aktuellesJahr = aktuellesJahr - 1;
            } else {
                aktuelleWoche = aktuelleWoche - 1;
            }

            new StundenPlanDownloader().execute();
        }
        if (v == btnForward) {
            if (aktuelleWoche == 52) {
                aktuelleWoche = 1;
                aktuellesJahr = aktuellesJahr + 1;
            } else {
                aktuelleWoche = aktuelleWoche + 1;
            }

            new StundenPlanDownloader().execute();
        }
    }
}
