
package com.tizianhoesch.gibmitnews.alarm;

import java.util.Calendar;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

public class AlarmService {
    private Context context;
    private PendingIntent mAlarmSender;

    public AlarmService(Context context) {
        this.context = context;
        Intent notifyIntent = new Intent(Intent.ACTION_MAIN);
        mAlarmSender = PendingIntent.getBroadcast(context, 0, notifyIntent, 0);
    }

    public void setRepeatAlarm(int stunde, int minute, boolean nextDay) {
        Calendar updateTime = Calendar.getInstance();

        updateTime.set(Calendar.HOUR_OF_DAY, stunde);
        updateTime.set(Calendar.MINUTE, minute);
        updateTime.set(Calendar.SECOND, 00);

        if (nextDay == true) {
            updateTime.add(Calendar.DAY_OF_MONTH, 1);
        }

        Log.i("GIBMITNews",
                "alarm stunde=" + stunde + " minute=" + minute + " nextDay="
                        + nextDay + " millis=" + updateTime.getTimeInMillis());

        AlarmManager am = (AlarmManager) context
                .getSystemService(Context.ALARM_SERVICE);
        am.setRepeating(AlarmManager.RTC_WAKEUP, updateTime.getTimeInMillis(),
                AlarmManager.INTERVAL_DAY, mAlarmSender);
    }
}
