
package com.tizianhoesch.gibmitnews.alarm;

import java.util.Calendar;
import java.util.Date;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;

import com.tizianhoesch.gibmitnews.GIBMITNewsActivity;
import com.tizianhoesch.gibmitnews.R;

public class TimeAlarm extends BroadcastReceiver {
    NotificationManager nm;

    @Override
    public void onReceive(Context context, Intent intent) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(context);
        Calendar cal = Calendar.getInstance();

        Log.i(GIBMITNewsActivity.TAG, "today=" + cal.get(Calendar.DAY_OF_WEEK));
        Log.i(GIBMITNewsActivity.TAG,
                "monday="
                        + app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("mo"));
        Log.i(GIBMITNewsActivity.TAG,
                "tuesday="
                        + app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("di"));
        Log.i(GIBMITNewsActivity.TAG,
                "wednesday="
                        + app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("mi"));
        Log.i(GIBMITNewsActivity.TAG,
                "thursday="
                        + app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("do"));
        Log.i(GIBMITNewsActivity.TAG,
                "friday="
                        + app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("fr"));
        Log.i(GIBMITNewsActivity.TAG,
                "saturday="
                        + app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("sa"));
        Log.i(GIBMITNewsActivity.TAG,
                "sunday="
                        + app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("so"));

        AlarmService as = new AlarmService(context);

        if (intent.getAction().equals("android.intent.action.BOOT_COMPLETED")) {
            Date jetzt = new Date();
            java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
                    "HH:mm");
            String ausgabe = sdf.format(jetzt);
            int prefsHrs = getHour(app_preferences.getString("time", "20:00"));
            int prefsMin = getMinutes(app_preferences
                    .getString("time", "20:00"));
            int jetztHrs = getHour(ausgabe);
            int jetztMin = getMinutes(ausgabe);

            String strJetztHrs = String.valueOf(jetztHrs);
            String strjetztMin = String.valueOf(jetztMin);
            String strprefsHrs = String.valueOf(prefsHrs);
            String strprefsMin = String.valueOf(prefsMin);

            if (String.valueOf(jetztHrs).length() == 1) {
                strJetztHrs = "0" + String.valueOf(jetztHrs);
            }
            if (String.valueOf(jetztMin).length() == 1) {
                strjetztMin = "0" + String.valueOf(jetztMin);
            }
            if (String.valueOf(prefsHrs).length() == 1) {
                strprefsHrs = "0" + String.valueOf(prefsHrs);
            }
            if (String.valueOf(prefsMin).length() == 1) {
                strprefsMin = "0" + String.valueOf(prefsMin);
            }

            String strResultJetzt = strJetztHrs + strjetztMin;
            String strResultPrefs = strprefsHrs + strprefsMin;

            if (Integer.parseInt(strResultJetzt) > Integer
                    .parseInt(strResultPrefs)) {
                as.setRepeatAlarm(
                        getHour(app_preferences.getString("time", "20:00")),
                        getMinutes(app_preferences.getString("time", "20:00")),
                        true);
            } else if (Integer.parseInt(strResultJetzt) < Integer
                    .parseInt(strResultPrefs)) {
                as.setRepeatAlarm(
                        getHour(app_preferences.getString("time", "20:00")),
                        getMinutes(app_preferences.getString("time", "20:00")),
                        false);
            }
        } else {
            if (app_preferences.getBoolean("enable", true) == true) {
                if (getDayOfWeek(cal.get(Calendar.DAY_OF_WEEK))
                        .equals("Montag")
                        && app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("mo") == true) {
                    showNotification(context);
                    Log.i(GIBMITNewsActivity.TAG, "showNotification=true");
                } else if (getDayOfWeek(cal.get(Calendar.DAY_OF_WEEK)).equals(
                        "Dienstag")
                        && app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("di") == true) {
                    showNotification(context);
                    Log.i(GIBMITNewsActivity.TAG, "showNotification=true");
                } else if (getDayOfWeek(cal.get(Calendar.DAY_OF_WEEK)).equals(
                        "Mittwoch")
                        && app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("mi") == true) {
                    showNotification(context);
                    Log.i(GIBMITNewsActivity.TAG, "showNotification=true");
                } else if (getDayOfWeek(cal.get(Calendar.DAY_OF_WEEK)).equals(
                        "Donnerstag")
                        && app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("do") == true) {
                    showNotification(context);
                    Log.i(GIBMITNewsActivity.TAG, "showNotification=true");
                } else if (getDayOfWeek(cal.get(Calendar.DAY_OF_WEEK)).equals(
                        "Freitag")
                        && app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("fr") == true) {
                    showNotification(context);
                    Log.i(GIBMITNewsActivity.TAG, "showNotification=true");
                } else if (getDayOfWeek(cal.get(Calendar.DAY_OF_WEEK)).equals(
                        "Samstag")
                        && app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("sa") == true) {
                    showNotification(context);
                    Log.i(GIBMITNewsActivity.TAG, "showNotification=true");
                } else if (getDayOfWeek(cal.get(Calendar.DAY_OF_WEEK)).equals(
                        "Sonntag")
                        && app_preferences.getString("weekdays",
                                "mo, di, mi, do, fr, sa, so").contains("so") == true) {
                    showNotification(context);
                    Log.i(GIBMITNewsActivity.TAG, "showNotification=true");
                } else {
                    Log.e(GIBMITNewsActivity.TAG, "showNotification=false");
                }
            }
        }
    }

    /**
     * Zeigt eine Notification an
     * 
     * @param myContext
     */
    public void showNotification(Context myContext) {
        Notification notification = new Notification(R.drawable.icon,
                "Bitte prfen Sie die GIBM News", System.currentTimeMillis());
        CharSequence contentTitle = "GIBM IT News";
        Intent notificationIntent = new Intent(myContext,
                GIBMITNewsActivity.class);
        PendingIntent contentIntent = PendingIntent.getActivity(myContext, 0,
                notificationIntent, 0);

        notification.setLatestEventInfo(myContext, contentTitle,
                "Bitte prfen Sie die GIBM News", contentIntent);
        notification.ledARGB = 0xff00ff00;
        notification.ledOnMS = 300;
        notification.ledOffMS = 5000;
        notification.flags += Notification.FLAG_SHOW_LIGHTS;
        notification.flags += Notification.FLAG_AUTO_CANCEL;

        long[] vibrate = {
                100, 100, 200, 300
        };
        notification.vibrate = vibrate;
        notification.defaults = Notification.DEFAULT_ALL;

        ((NotificationManager) myContext
                .getSystemService(Context.NOTIFICATION_SERVICE)).notify(
                GIBMITNewsActivity.NOTIFICATION_ID, notification);
    }

    /**
     * Extrahiert die Minuten aus einem Zeit String im Format hh:mm
     * 
     * @param zeit
     * @return minuten
     */
    private int getMinutes(String zeit) {
        return Integer.valueOf(zeit.split(":")[1]);
    }

    /**
     * Extrahiert die Stunden aus einem Zeit String im Format hh:mm
     * 
     * @param zeit
     * @return stunden
     */
    private int getHour(String zeit) {
        return Integer.valueOf(zeit.split(":")[0]);
    }

    /**
     * Macht aus einer Zahl einen String mit dem Wochentag
     * 
     * @param dayOfWeek
     * @return String mit Wochentag
     */
    private String getDayOfWeek(int dayOfWeek) {
        switch (dayOfWeek) {
            case 1:
                return "Sonntag";
            case 2:
                return "Montag";
            case 3:
                return "Dienstag";
            case 4:
                return "Mittwoch";
            case 5:
                return "Donnerstag";
            case 6:
                return "Freitag";
            case 7:
                return "Samstag";
        }
        return "Error";
    }
}
