
package com.tizianhoesch.gibmitnews.database;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

class KlassenlisteDatabaseHelper extends SQLiteOpenHelper {
    private static final int DATABASE_VERSION = 1;

    private static final String DATABASE_CREATE = "create table "
            + KlassenlisteDbAdapter.DATABASE_TABLE
            + " (_id integer primary key autoincrement, "
            + KlassenlisteDbAdapter.KEY_KLASSENID + " text not null, "
            + KlassenlisteDbAdapter.KEY_KLASSENKUERZEL + " text not null);";

    KlassenlisteDatabaseHelper(Context context) {
        super(context, KlassenlisteDbAdapter.DATABASE_TABLE, null,
                DATABASE_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase database) {
        database.execSQL(DATABASE_CREATE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase database, int oldVersion,
            int newVersion) {
        Log.w(KlassenlisteDatabaseHelper.class.getName(),
                "Upgrading database from version " + oldVersion + " to "
                        + newVersion + ", which will destroy all old data");
        database.execSQL("DROP TABLE IF EXISTS todo");
        onCreate(database);
    }
}
