
package com.tizianhoesch.gibmitnews.database;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

class LehrerlisteDatabaseHelper extends SQLiteOpenHelper {
    private static final int DATABASE_VERSION = 1;

    private static final String DATABASE_CREATE = "create table "
            + LehrerlisteDbAdapter.DATABASE_TABLE
            + " (_id integer primary key autoincrement, "
            + LehrerlisteDbAdapter.KEY_LEHRERID + " text not null, "
            + LehrerlisteDbAdapter.KEY_LEHRERNAME + " text not null);";

    LehrerlisteDatabaseHelper(Context context) {
        super(context, LehrerlisteDbAdapter.DATABASE_TABLE, null,
                DATABASE_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase database) {
        database.execSQL(DATABASE_CREATE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase database, int oldVersion,
            int newVersion) {
        Log.w(LehrerlisteDatabaseHelper.class.getName(),
                "Upgrading database from version " + oldVersion + " to "
                        + newVersion + ", which will destroy all old data");
        database.execSQL("DROP TABLE IF EXISTS "
                + LehrerlisteDbAdapter.DATABASE_TABLE);
        onCreate(database);
    }
}
