
package com.tizianhoesch.gibmitnews.database;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;

public class LehrerlisteDbAdapter {
    private static final String KEY_ROWID = "_id";
    public static final String KEY_LEHRERID = "lehrerid";
    public static final String KEY_LEHRERNAME = "lehrername";
    static final String DATABASE_TABLE = "lehrerliste";
    private Context myContext;
    private SQLiteDatabase database;
    private LehrerlisteDatabaseHelper dbHelper;

    public LehrerlisteDbAdapter(Context context) {
        this.myContext = context;
    }

    public LehrerlisteDbAdapter open() throws SQLException {
        dbHelper = new LehrerlisteDatabaseHelper(myContext);
        database = dbHelper.getWritableDatabase();
        return this;
    }

    public void close() {
        dbHelper.close();
    }

    public long createLehrer(String lehrerId, String lehrerName) {
        ContentValues initialValues = createContentValues(lehrerId, lehrerName);

        return database.insert(DATABASE_TABLE, null, initialValues);
    }

    public Cursor fetchAllLehrer() {
        return database.query(DATABASE_TABLE, new String[] {
                KEY_ROWID,
                KEY_LEHRERID, KEY_LEHRERNAME
        }, null, null, null, null, null);
    }

    public Cursor fetchLehrer(String kuerzel) {
        return database.query(DATABASE_TABLE, new String[] {
                KEY_LEHRERID
        },
                KEY_LEHRERNAME + " LIKE '" + kuerzel + "'", null, null, null,
                null);
    }

    private ContentValues createContentValues(String category, String summary) {
        ContentValues values = new ContentValues();
        values.put(KEY_LEHRERID, category);
        values.put(KEY_LEHRERNAME, summary);
        return values;
    }

    public void clearTable() {
        final String DATABASE_DROP = "delete from " + DATABASE_TABLE + ";";

        database.execSQL(DATABASE_DROP);
    }
}
