
package com.tizianhoesch.gibmitnews.database;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

class NewsDatabaseHelper extends SQLiteOpenHelper {
    private static final int DATABASE_VERSION = 1;

    private static final String DATABASE_CREATE = "create table "
            + NewsDbAdapter.DATABASE_TABLE
            + " (_id integer primary key autoincrement, "
            + NewsDbAdapter.KEY_NEWS + " text not null, "
            + NewsDbAdapter.KEY_PUBDATE + " text not null);";

    NewsDatabaseHelper(Context context) {
        super(context, NewsDbAdapter.DATABASE_TABLE, null, DATABASE_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase database) {
        database.execSQL(DATABASE_CREATE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase database, int oldVersion,
            int newVersion) {
        Log.w(NewsDatabaseHelper.class.getName(),
                "Upgrading database from version " + oldVersion + " to "
                        + newVersion + ", which will destroy all old data");
        database.execSQL("DROP TABLE IF EXISTS " + NewsDbAdapter.DATABASE_TABLE);
        onCreate(database);
    }
}
