
package com.tizianhoesch.gibmitnews.database;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;

public class NewsDbAdapter {
    private static final String KEY_ROWID = "_id";
    public static final String KEY_NEWS = "tweet";
    public static final String KEY_PUBDATE = "pubdate";
    static final String DATABASE_TABLE = "cachedtweets";
    private Context myContext;
    private SQLiteDatabase database;
    private NewsDatabaseHelper dbHelper;

    public NewsDbAdapter(Context context) {
        this.myContext = context;
    }

    public NewsDbAdapter open() throws SQLException {
        dbHelper = new NewsDatabaseHelper(myContext);
        database = dbHelper.getWritableDatabase();
        return this;
    }

    public void close() {
        dbHelper.close();
    }

    public long createTweet(String tweet, String pubdate) {
        ContentValues initialValues = createContentValues(tweet, pubdate);

        return database.insert(DATABASE_TABLE, null, initialValues);
    }

    public Cursor fetchAllNews() {
        return database.query(DATABASE_TABLE, new String[] {
                KEY_ROWID,
                KEY_NEWS, KEY_PUBDATE
        }, null, null, null, null, null);
    }

    private ContentValues createContentValues(String category, String summary) {
        ContentValues values = new ContentValues();
        values.put(KEY_NEWS, category);
        values.put(KEY_PUBDATE, summary);
        return values;
    }

    public void clearTable() {
        final String DATABASE_DROP = "delete from " + DATABASE_TABLE + ";";

        database.execSQL(DATABASE_DROP);
    }
}
