
package com.tizianhoesch.gibmitnews.push;

import java.util.Arrays;
import java.util.List;
import java.util.Set;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

import com.tizianhoesch.gibmitnews.GIBMITNewsActivity;
import com.urbanairship.Logger;
import com.urbanairship.UAirship;
import com.urbanairship.push.PushManager;

public class IntentReceiver extends BroadcastReceiver {
    @Override
    public void onReceive(Context aContext, Intent aIntent) {
        Log.i(GIBMITNewsActivity.TAG, "intent received: " + aIntent.toString());
        String action = aIntent.getAction();

        if (action.equals(PushManager.ACTION_PUSH_RECEIVED)) {

            int id = aIntent.getIntExtra(PushManager.EXTRA_NOTIFICATION_ID, 0);

            Log.i(GIBMITNewsActivity.TAG,
                    "push received, message: "
                            + aIntent.getStringExtra(PushManager.EXTRA_ALERT)
                            + ", id=" + id);

            logPushExtras(aIntent);
        } else if (action.equals(PushManager.ACTION_NOTIFICATION_OPENED)) {
            Log.i(GIBMITNewsActivity.TAG, "push notification opened, message: "
                    + aIntent.getStringExtra(PushManager.EXTRA_ALERT));

            logPushExtras(aIntent);

            Intent launch = new Intent(Intent.ACTION_MAIN);
            launch.setClass(UAirship.shared().getApplicationContext(),
                    GIBMITNewsActivity.class);
            launch.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);

            UAirship.shared().getApplicationContext().startActivity(launch);
        } else if (action.equals(PushManager.ACTION_REGISTRATION_FINISHED)) {
            Logger.info("device registrated, APID="
                    + aIntent.getStringExtra(PushManager.EXTRA_APID)
                    + ", valid="
                    + aIntent.getBooleanExtra(
                            PushManager.EXTRA_REGISTRATION_VALID, false));
        }
    }

    private void logPushExtras(Intent intent) {
        Set<String> keys = intent.getExtras().keySet();
        for (String key : keys) {

            List<String> ignoredKeys = (List<String>) Arrays.asList(
                    "collapse_key", "from", PushManager.EXTRA_NOTIFICATION_ID,
                    PushManager.EXTRA_PUSH_ID, PushManager.EXTRA_ALERT);
            if (ignoredKeys.contains(key)) {
                continue;
            }
            Log.i(GIBMITNewsActivity.TAG, "push extra: [" + key + " : "
                    + intent.getStringExtra(key) + "]");
        }
    }
}
