
package com.tizianhoesch.gibmitnews.push;

import java.util.Calendar;
import java.util.Date;

import android.app.Application;
import android.content.Context;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;

import com.tizianhoesch.gibmitnews.GIBMITNewsActivity;
import com.urbanairship.Logger;
import com.urbanairship.UAirship;
import com.urbanairship.push.PushManager;
import com.urbanairship.push.PushPreferences;

public class NotifyMeApplication extends Application {
    Context myContext = this;

    @Override
    public void onCreate() {
        super.onCreate();
        UAirship.takeOff(this);
        Logger.logLevel = Log.DEBUG;
        PushManager.shared().setIntentReceiver(IntentReceiver.class);
        PushPreferences prefs = PushManager.shared().getPreferences();

        boolean quietTime = getBoolean("enablepush", true);

        String zeit1 = getString("pushtime", "22:00");
        String zeit2 = getString("pushtime2", "08:00");

        int prefsHrs = getHour(zeit1);
        int prefsMin = getMinutes(zeit1);
        int prefsHrs2 = getHour(zeit2);
        int prefsMin2 = getMinutes(zeit2);

        if (quietTime == true) {
            Log.i(GIBMITNewsActivity.TAG, "push enabled");
            Calendar cal = Calendar.getInstance();
            cal.set(Calendar.HOUR_OF_DAY, prefsHrs);
            cal.set(Calendar.MINUTE, prefsMin);
            Date startDate = cal.getTime();

            Calendar cal2 = Calendar.getInstance();
            cal2.set(Calendar.HOUR_OF_DAY, prefsHrs2);
            cal2.set(Calendar.MINUTE, prefsMin2);
            Date endDate = cal2.getTime();

            prefs.setQuietTimeEnabled(true);
            prefs.setQuietTimeInterval(startDate, endDate);
            prefs.setSoundEnabled(true);
            prefs.setVibrateEnabled(true);
            PushManager.enablePush();
        } else {
            Log.i(GIBMITNewsActivity.TAG, "push disabled()");
            prefs.setQuietTimeEnabled(false);
            PushManager.disablePush();
        }
    }

    public void onStop() {
        UAirship.land();
    }

    private boolean getBoolean(String keyName, boolean value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);

        boolean variable = app_preferences.getBoolean(keyName, value);

        Log.i(GIBMITNewsActivity.TAG, "mode=get type=boolean defaultvalue="
                + value + " key=" + keyName + " returned=" + variable);
        return variable;
    }

    private String getString(String keyName, String value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(this);

        String variable = app_preferences.getString(keyName, value);

        Log.i(GIBMITNewsActivity.TAG, "mode=get type=string defaultvalue="
                + value + " key=" + keyName + " returned=" + variable);
        return variable;
    }

    private int getHour(String zeit) {
        return Integer.valueOf(zeit.split(":")[0]);
    }

    private int getMinutes(String zeit) {
        return Integer.valueOf(zeit.split(":")[1]);
    }

    // public String getEmailAddress() {
    // AccountManager manager = AccountManager.get(this);
    // Account[] accounts = manager.getAccountsByType("com.google");
    // List<String> possibleEmails = new LinkedList<String>();
    //
    // for (Account account : accounts) {
    // possibleEmails.add(account.name);
    // }
    //
    // if (!possibleEmails.isEmpty() && possibleEmails.get(0) != null) {
    // String email = possibleEmails.get(0);
    // return email;
    // } else
    // return "-";
    // }

    // public String findDeviceID() {
    // String deviceID = null;
    // String serviceName = Context.TELEPHONY_SERVICE;
    // TelephonyManager m_telephonyManager = (TelephonyManager)
    // getSystemService(serviceName);
    // int deviceType = m_telephonyManager.getPhoneType();
    // switch (deviceType) {
    // case (TelephonyManager.PHONE_TYPE_GSM):
    // break;
    // case (TelephonyManager.PHONE_TYPE_CDMA):
    // break;
    // case (TelephonyManager.PHONE_TYPE_NONE):
    // break;
    // default:
    // break;
    // }
    // if (!m_telephonyManager.getDeviceId().equals(null)
    // || !m_telephonyManager.getDeviceId().equals("")) {
    // deviceID = m_telephonyManager.getDeviceId();
    // }
    // return deviceID;
    // }
}
