
package com.tizianhoesch.gibmitnews.tools;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.SimpleCursorAdapter;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.tizianhoesch.gibmitnews.GIBMITNewsActivity;
import com.tizianhoesch.gibmitnews.R;
import com.tizianhoesch.gibmitnews.database.KlassenlisteDbAdapter;
import com.tizianhoesch.gibmitnews.database.LehrerlisteDbAdapter;

public class BerufLehrerDlg extends Activity {

    private KlassenlisteDbAdapter dbHelperKlasse;
    private LehrerlisteDbAdapter dbHelperLehrer;

    Dialog derDialog;

    TextView txtChoose;
    TextView txtChoose2;
    Spinner typSpinner;
    Spinner berufSpinner;
    Spinner klassenSpinner;
    View dummy1;
    View dummy2;
    View dummy3;
    View dummy4;

    private int m_intSpinnerInitiCount = 0;
    private static final int NO_OF_EVENTS = 1;
    private int m_intSpinnerInitiCount2 = 0;
    private static final int NO_OF_EVENTS2 = 1;

    Context myContext = this;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.berufwaehlen);

        derDialog = new Dialog(this);
        txtChoose = (TextView) findViewById(R.id.txtChoose);
        txtChoose2 = (TextView) findViewById(R.id.txtChoose2);
        typSpinner = (Spinner) findViewById(R.id.typSpinner);
        berufSpinner = (Spinner) findViewById(R.id.berufSpinner);
        klassenSpinner = (Spinner) findViewById(R.id.klasseSpinner);
        dummy1 = (View) findViewById(R.id.dummy1);
        dummy2 = (View) findViewById(R.id.dummy2);
        dummy3 = (View) findViewById(R.id.dummy3);
        dummy4 = (View) findViewById(R.id.dummy4);
        Button berufSpeichern = (Button) findViewById(R.id.btnOkBeruf);
        berufSpeichern.setOnClickListener(new View.OnClickListener() {
            long txtBerufID;
            String txtKlasseID;

            @Override
            public void onClick(View arg0) {
                if (typSpinner.getSelectedItemPosition() == 1) {
                    saveString("typ", "schueler");
                    txtBerufID = berufSpinner.getSelectedItemId();
                    if (klassenSpinner.getSelectedItemPosition() >= 0) {
                        txtKlasseID = klassenSpinner.getItemAtPosition(
                                klassenSpinner.getSelectedItemPosition())
                                .toString();

                        Cursor cc = (Cursor) (klassenSpinner.getSelectedItem());
                        if (cc != null) {
                            txtKlasseID = cc.getString(cc
                                    .getColumnIndex(KlassenlisteDbAdapter.KEY_KLASSENKUERZEL));
                        }

                        String klasseID = getKlassenIDFromName(txtKlasseID);
                        saveString("beruf", "" + txtBerufID);
                        saveString("klasse", "" + klasseID);
                        finish();
                    } else {
                        makeToast(
                                "Bitte whlen Sie einen Beruf und eine Klasse aus!",
                                true);
                    }
                } else if (typSpinner.getSelectedItemPosition() == 2) {
                    saveString("typ", "lehrer");
                    txtBerufID = berufSpinner.getSelectedItemId();
                    if (klassenSpinner.getSelectedItemPosition() >= 0) {
                        txtKlasseID = klassenSpinner.getItemAtPosition(
                                klassenSpinner.getSelectedItemPosition())
                                .toString();

                        Cursor cc = (Cursor) (klassenSpinner.getSelectedItem());
                        if (cc != null) {
                            txtKlasseID = cc.getString(cc
                                    .getColumnIndex(LehrerlisteDbAdapter.KEY_LEHRERNAME));
                        }

                        String klasseID = getLehrerIDFromName(txtKlasseID);
                        saveString("beruf", "" + txtBerufID);
                        saveString("klasse", "" + klasseID);
                        finish();
                    } else {
                        makeToast(
                                "Bitte whlen Sie einen Beruf und eine Klasse aus!",
                                true);
                    }
                } else {
                    makeToast(
                            "Bitte geben Sie an, ob Sie Lehrer oder Schler sind",
                            true);
                    return;
                }
            }
        });
        dummy1.setVisibility(View.GONE);
        txtChoose.setVisibility(View.GONE);
        berufSpinner.setVisibility(View.GONE);
        dummy2.setVisibility(View.GONE);
        dummy3.setVisibility(View.GONE);
        txtChoose2.setVisibility(View.GONE);
        klassenSpinner.setVisibility(View.GONE);
        dummy4.setVisibility(View.GONE);
        typSpinner.setOnItemSelectedListener(new OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parentView,
                    View selectedItemView, int position, long id) {
                final ProgressDialog dialogs;
                if (m_intSpinnerInitiCount2 < NO_OF_EVENTS2) {
                    m_intSpinnerInitiCount2++;
                } else {
                    switch (position) {
                        case 0:
                            // nothing...
                            break;
                        case 1:
                            ArrayAdapter<CharSequence> adapter = ArrayAdapter
                                    .createFromResource(myContext, R.array.berufe,
                                            android.R.layout.simple_spinner_item);
                            adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
                            berufSpinner.setAdapter(adapter);
                            dummy1.setVisibility(View.VISIBLE);
                            dummy2.setVisibility(View.VISIBLE);
                            txtChoose.setVisibility(View.VISIBLE);
                            txtChoose.setText("Bitte whlen Sie Ihren Beruf aus:");
                            berufSpinner.setVisibility(View.VISIBLE);

                            dummy3.setVisibility(View.GONE);
                            dummy4.setVisibility(View.GONE);
                            txtChoose2.setVisibility(View.GONE);
                            klassenSpinner.setVisibility(View.GONE);
                            break;
                        case 2:
                            dialogs = new ProgressDialog(myContext);
                            dialogs.setMessage("Die Lehrerliste wird geladen...");
                            dialogs.setCancelable(false);
                            dialogs.setCanceledOnTouchOutside(false);
                            dialogs.show();
                            final Handler handler = new Handler() {
                                public void handleMessage(Message msg) {
                                    getDatabaseToSpinnerLehrer();
                                    dialogs.dismiss();
                                }
                            };
                            Thread checkUpdate = new Thread() {
                                public void run() {
                                    lehrerListeAktualisieren();
                                    handler.sendEmptyMessage(0);
                                }
                            };
                            checkUpdate.start();
                            break;
                    }
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
                // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\
                // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\
                // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\
                // \\ // \\ // \\ HAHAHAHA FUNNY ^^ // \\ // \\ // \\
                // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\
                // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\
                // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\
                // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\ // \\
            }
        });
        berufSpinner.setOnItemSelectedListener(new OnItemSelectedListener() {
            long txtBerufID;
            ProgressDialog dialogs;

            @Override
            public void onItemSelected(AdapterView<?> parentView,
                    View selectedItemView, int position, long id) {
                if (m_intSpinnerInitiCount < NO_OF_EVENTS) {
                    m_intSpinnerInitiCount++;
                } else {
                    txtBerufID = berufSpinner.getSelectedItemId();
                    if (txtBerufID > 0) {
                        dialogs = new ProgressDialog(myContext);
                        dialogs.setMessage("Die Klassenliste wird geladen...");
                        dialogs.show();
                        final Handler handler = new Handler() {
                            public void handleMessage(Message msg) {
                                getDatabaseToSpinner();
                                dialogs.dismiss();
                            }
                        };
                        Thread checkUpdate = new Thread() {
                            public void run() {
                                klassenListeAktualisieren((new Long(txtBerufID))
                                        .toString());
                                handler.sendEmptyMessage(0);
                            }
                        };
                        checkUpdate.start();
                    }
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parentView) {
                // should usually not happen...
            }

        });
    }

    /**
     * Sucht in der Datenbank nach der dem ID einer Klasse durch den Namen
     * 
     * @param klassenName
     * @return die ID der Klasse
     */
    private String getKlassenIDFromName(String klassenName) {
        dbHelperKlasse = new KlassenlisteDbAdapter(myContext);
        dbHelperKlasse.open();

        Cursor einzelneKlasse = dbHelperKlasse.fetchKlasse(klassenName);
        startManagingCursor(einzelneKlasse);

        einzelneKlasse.moveToFirst();
        String diesnDa = "";
        while (!einzelneKlasse.isAfterLast()) {
            diesnDa = einzelneKlasse.getString(einzelneKlasse
                    .getColumnIndex(KlassenlisteDbAdapter.KEY_KLASSENID));
            einzelneKlasse.moveToNext();
        }
        return diesnDa;
    }

    /**
     * Liefert einen Klassenname von der Datenbank durch die ID der Klasse
     * 
     * @param klassenID
     * @return den Klassennamen
     */
    @SuppressWarnings("unused")
    private String getNameFromKlassenID(String klassenID) {
        dbHelperKlasse = new KlassenlisteDbAdapter(myContext);
        dbHelperKlasse.open();

        Cursor einzelneKlasse = dbHelperKlasse.fetchKlasseByID(klassenID);
        startManagingCursor(einzelneKlasse);

        einzelneKlasse.moveToFirst();
        String diesnDa = "";
        while (!einzelneKlasse.isAfterLast()) {
            diesnDa = einzelneKlasse.getString(einzelneKlasse
                    .getColumnIndex(KlassenlisteDbAdapter.KEY_KLASSENKUERZEL));
            einzelneKlasse.moveToNext();
        }
        return diesnDa;
    }

    /**
     * Sucht in der Datenbank nach der ID eines gegebenen Lehrers
     * 
     * @param lehrerName
     * @return die ID des Lehrers
     */
    private String getLehrerIDFromName(String lehrerName) {
        dbHelperLehrer = new LehrerlisteDbAdapter(myContext);
        dbHelperLehrer.open();

        Cursor einzelnerLehrer = dbHelperLehrer.fetchLehrer(lehrerName);
        startManagingCursor(einzelnerLehrer);

        einzelnerLehrer.moveToFirst();
        String diesnDa = "";
        while (!einzelnerLehrer.isAfterLast()) {
            diesnDa = einzelnerLehrer.getString(einzelnerLehrer
                    .getColumnIndex(LehrerlisteDbAdapter.KEY_LEHRERID));
            einzelnerLehrer.moveToNext();
        }
        return diesnDa;
    }

    /**
     * Speichert einen string in die Shared Preferences
     * 
     * @param keyName
     * @param value
     */
    private void saveString(String keyName, String value) {
        SharedPreferences app_preferences = PreferenceManager
                .getDefaultSharedPreferences(myContext);
        SharedPreferences.Editor pref_editor = app_preferences.edit();

        Log.i(GIBMITNewsActivity.TAG, "mode=save type=string value=" + value
                + " key=" + keyName);

        pref_editor.putString(keyName, value);
        pref_editor.commit();
    }

    /**
     * Erstellt eine Toast Nachricht mit dem gegebenen Text
     * 
     * @param message
     * @param lengthlong
     */
    private void makeToast(String message, boolean lengthlong) {
        CharSequence text = message;
        int duration;

        if (lengthlong == true) {
            duration = Toast.LENGTH_LONG;
        } else {
            duration = Toast.LENGTH_SHORT;
        }

        Log.i(GIBMITNewsActivity.TAG, "toast titel=" + message
                + " length_long=" + lengthlong);

        Toast toast = Toast.makeText(myContext, text, duration);
        toast.show();
    }

    /**
     * Ldt alle Klassen aus Datenbank in den Spinner
     */
    private void getDatabaseToSpinner() {
        dbHelperKlasse = new KlassenlisteDbAdapter(myContext);
        dbHelperKlasse.open();

        Cursor cursor_Names = dbHelperKlasse.fetchAllKlassen();
        stopManagingCursor(cursor_Names);
        startManagingCursor(cursor_Names);
        cursor_Names.requery();

        String[] columns = new String[] {
                KlassenlisteDbAdapter.KEY_KLASSENKUERZEL
        };
        int[] to = new int[] {
                android.R.id.text1
        };

        SimpleCursorAdapter mAdapter = new SimpleCursorAdapter(myContext,
                android.R.layout.simple_spinner_item, cursor_Names, columns, to);
        mAdapter.changeCursor(cursor_Names);
        mAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        klassenSpinner.setAdapter(mAdapter);

        txtChoose.setVisibility(View.VISIBLE);
        txtChoose2.setVisibility(View.VISIBLE);
        berufSpinner.setVisibility(View.VISIBLE);
        klassenSpinner.setVisibility(View.VISIBLE);
        dummy1.setVisibility(View.VISIBLE);
        dummy2.setVisibility(View.VISIBLE);
        dummy3.setVisibility(View.VISIBLE);
        dummy4.setVisibility(View.VISIBLE);

        dbHelperKlasse.close();
    }

    /**
     * Ldt alle Lehrer aus Datenbank in den Spinner
     */
    private void getDatabaseToSpinnerLehrer() {
        dbHelperLehrer = new LehrerlisteDbAdapter(myContext);
        dbHelperLehrer.open();

        Cursor cursor_Names = dbHelperLehrer.fetchAllLehrer();
        stopManagingCursor(cursor_Names);
        startManagingCursor(cursor_Names);
        cursor_Names.requery();

        String[] columns = new String[] {
                LehrerlisteDbAdapter.KEY_LEHRERNAME
        };
        int[] to = new int[] {
                android.R.id.text1
        };

        SimpleCursorAdapter mAdapter = new SimpleCursorAdapter(myContext,
                android.R.layout.simple_spinner_item, cursor_Names, columns, to);
        mAdapter.changeCursor(cursor_Names);
        mAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        klassenSpinner.setAdapter(mAdapter);

        txtChoose.setText("Bitte whlen Sie Ihren Namen:");
        txtChoose.setVisibility(View.VISIBLE);
        txtChoose2.setVisibility(View.GONE);
        klassenSpinner.setVisibility(View.VISIBLE);
        berufSpinner.setVisibility(View.GONE);
        dummy1.setVisibility(View.VISIBLE);
        dummy2.setVisibility(View.VISIBLE);
        dummy3.setVisibility(View.GONE);
        dummy4.setVisibility(View.GONE);
        dbHelperLehrer.close();
    }

    /**
     * Ldt die komplette Liste aller Lehrer der Schule und speichert sie in
     * einer Datenbank
     */
    private void lehrerListeAktualisieren() {
        try {
            HttpClient client = new DefaultHttpClient();
            HttpGet method = new HttpGet(
                    "http://home.gibm.ch/interfaces/gibmapp/lehrerliste.php");
            client.execute(method);
            URL twitter = new URL(
                    "http://home.gibm.ch/interfaces/gibmapp/lehrerliste.json");
            URLConnection tc = twitter.openConnection();
            BufferedReader in = new BufferedReader(new InputStreamReader(
                    tc.getInputStream()));

            dbHelperLehrer = new LehrerlisteDbAdapter(myContext);
            dbHelperLehrer.open();
            dbHelperLehrer.clearTable();

            String line;
            while ((line = in.readLine()) != null) {
                JSONArray ja = new JSONArray(line);

                for (int i = 0; i < ja.length(); i++) {
                    JSONObject jo = (JSONObject) ja.get(i);
                    dbHelperLehrer.createLehrer(jo.getString("lehrer_id"),
                            jo.getString("lehrer_name"));
                }
            }
            dbHelperLehrer.close();
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    /**
     * Aktualisiert die Liste aller Klassen in einem bestimmten Beruf und
     * speichert sie in einer Datenbank
     * 
     * @param berufsId
     */
    private void klassenListeAktualisieren(String berufsId) {
        try {
            HttpClient client = new DefaultHttpClient();
            HttpGet method = new HttpGet(
                    "http://home.gibm.ch/interfaces/gibmapp/klassenliste.php?beruf="
                            + berufsId);
            client.execute(method);
            URL twitter = new URL(
                    "http://home.gibm.ch/interfaces/gibmapp/klassenliste.json");
            URLConnection tc = twitter.openConnection();
            BufferedReader in = new BufferedReader(new InputStreamReader(
                    tc.getInputStream()));

            dbHelperKlasse = new KlassenlisteDbAdapter(myContext);
            dbHelperKlasse.open();
            dbHelperKlasse.clearTable();

            String line;
            while ((line = in.readLine()) != null) {
                JSONArray ja = new JSONArray(line);

                for (int i = 0; i < ja.length(); i++) {
                    JSONObject jo = (JSONObject) ja.get(i);
                    dbHelperKlasse.createKlasse(jo.getString("klasse_id"),
                            jo.getString("klassekuerzel"));
                }
            }
            dbHelperKlasse.close();
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }
}
