
package com.tizianhoesch.gibmitnews.tools;

import java.util.Calendar;
import java.util.Date;

public class Utility {
    /**
     * Berechnet die Differenz zweier Daten
     * 
     * @param thenDate
     * @return String mit Vor ... Minuten/Stunden/Tagen etc.
     */
    public static String getDateDifference(Date thenDate) {
        Calendar now = Calendar.getInstance();
        Calendar then = Calendar.getInstance();
        now.setTime(new Date());
        then.setTime(thenDate);

        long nowMs = now.getTimeInMillis();
        long thenMs = then.getTimeInMillis();

        long diff = nowMs - thenMs;

        long diffMinutes = diff / (60 * 1000);
        long diffHours = diff / (60 * 60 * 1000);
        long diffDays = diff / (24 * 60 * 60 * 1000);
        long diffWeeks = diff / (7 * 24 * 60 * 60 * 1000);
        long diffMonths = diff / (4 * 7 * 24 * 60 * 60 * 1000);
        long diffYears = diff / (365 * 24 * 60 * 60 * 1000);

        if (diffMinutes < 60) {
            if (diffMinutes == 1)
                return "Vor " + diffMinutes + " Minute";
            else
                return "Vor " + diffMinutes + " Minuten";
        } else if (diffHours < 24) {
            if (diffHours == 1)
                return "Vor " + diffHours + " Stunde";
            else
                return "Vor " + diffHours + " Stunden";
        } else if (diffDays < 7) {
            if (diffDays == 1)
                return "Vor " + diffDays + " Tag";
            else
                return "Vor " + diffDays + " Tagen";
        } else if (diffWeeks < 4) {
            if (diffWeeks == 1)
                return "Vor " + diffWeeks + " Woche";
            else
                return "Vor " + diffWeeks + " Wochen";
        } else if (diffMonths < 12) {
            if (diffMonths == 1)
                return "Vor " + (diffMonths + 4) + " Monat";
            else
                return "Vor " + (diffMonths + 4) + " Monaten";
        } else if (diffYears < 3) {
            if (diffYears == 1)
                return "Vor " + diffYears + " Jahr";
            else
                return "Vor " + diffYears + " Jahren";
        } else {
            return "Vor einer langen Zeit";
        }
    }

    /**
     * Extrahiert die Minuten aus einem Zeit String im Format hh:mm
     * 
     * @param zeit
     * @return minuten
     */
    public static int getMinutes(String zeit) {
        return Integer.valueOf(zeit.split(":")[1]);
    }

    /**
     * Extrahiert die Stunden aus einem Zeit String im Format hh:mm
     * 
     * @param zeit
     * @return stunden
     */
    public static int getHour(String zeit) {
        return Integer.valueOf(zeit.split(":")[0]);
    }

    /**
     * Prft ob die gegebene Zahl 1 durch die gegebene Zahl 2 teilbar ist
     * 
     * @param zahl
     * @param teilbarDurch
     * @return wahr oder falsch
     */
    public static boolean isDividable(int zahl, int teilbarDurch) {
        if (zahl % teilbarDurch == 0) {
            return true;
        } else {
            return false;
        }
    }
}
